import Client from "./Client";
import { tribulle } from "../enums";
import { ByteArray } from "../utils";
declare interface TribullePacketHandler {
    client: Client;
    [index: number]: (packet: ByteArray) => void;
}
declare class TribullePacketHandler {
    /**
     * Transformice client instance
     */
    client: Client;
    constructor(client: Client);
    [tribulle.whisper](packet: ByteArray): void;
    [tribulle.friendList](packet: ByteArray): void;
    [tribulle.friendConnect](packet: ByteArray): void;
    [tribulle.friendDisconnect](packet: ByteArray): void;
    [tribulle.friendChange](packet: ByteArray): void;
    [tribulle.channelWho](packet: ByteArray): void;
    [tribulle.channelLeave](packet: ByteArray): void;
    [tribulle.channelJoin](packet: ByteArray): void;
    [tribulle.channelMessage](packet: ByteArray): void;
    [tribulle.tribeMessage](packet: ByteArray): void;
    [tribulle.tribeMemberConnect](packet: ByteArray): void;
    [tribulle.tribeMemberDisconnect](packet: ByteArray): void;
}
export default TribullePacketHandler;
