"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
/** Represents a Channel message. */
var ChannelMessage = /** @class */ (function (_super) {
    __extends(ChannelMessage, _super);
    /**
     * @hidden
     */
    function ChannelMessage(client, author, content, community, channel) {
        var _this = _super.call(this, client, author, content) || this;
        _this.community = community;
        _this.channel = channel;
        return _this;
    }
    /**
     * Reply the author with a message.
     *
     * @example
     * ```js
     * client.on('roomMessage', (message) => {
     * 	if (client.name === message.author.name)
     * 		return;
     * 	message.reply('Hello');
     * }
     * ```
     */
    ChannelMessage.prototype.reply = function (message) {
        this.client.sendRoomMessage("@" + this.author.name + " " + message);
    };
    return ChannelMessage;
}(_1.Message));
exports.default = ChannelMessage;
